import "Vector3" for Vector3
import "Turok3Helpers" for Turok3Interface, CGameObjectInstance, CPlayer

// Sensitivty scale
var M_MUL = 1
// Vertical sensitivity
var M_PITCH = 0.0025
// Horizontal sensitivity
var M_YAW = 0.0025
//Field of view (max is 90) 
// TO USE THIS YOU MUST RUN THE GAME WITH --emumode 0; THIS DOES NOT WORK WITH CACHED INTERPRETER OR DYNAMIC RECOMPILER!!
var FOV = 70

// Target fps
var FPSMODE = Turok3Interface.FPS30 //FPS15, FPS30, FPS60, FPSMAX
var FPSSCALE = Turok3Interface.FPS30SCALE //FPS15SCALE, FPS30SCALE, FPS60SCALE

// Not implemented; ignore
var SCALETOFPS = false

// Time before mouse input begins; softlocks in the main menu
var TIMEBEFOREEXECUTE = 500

// Do not touch below!

// Userdata
var PITCH = 0
var YAW = 0
var DELTAX = 0
var DELTAY = 0
var PPOINTER = 0
var PPOINTERLAST = 0
var PLAYER = CPlayer.new()

// Constants
var RAD2DEG = 57.29578049
var DEG2RAD = 0.01745329
var TAU = Num.pi * 2
var HPI = Num.pi / 2
var MINA = -89.999998 * DEG2RAD
var MAXA = 89.999998 * DEG2RAD

class mupen {
    // Get rdram methods from C
    foreign static rdramRead8(addr)
    foreign static rdramWrite8(addr, input)
    foreign static rdramRead16(addr)
    foreign static rdramWrite16(addr, input)
    foreign static rdramRead32(addr)
    foreign static rdramReadf32(addr)
    foreign static rdramWrite32(addr, input)
    foreign static rdramWritef32(addr, input)
    foreign static rdramReadBuffer(addr, length)
    foreign static rdramWriteBuffer(addr, buf)

    // Get rom methods from C
    foreign static romRead8(addr)
    foreign static romWrite8(addr, input)
    foreign static romRead16(addr)
    foreign static romWrite16(addr, input)
    foreign static romRead32(addr)
    foreign static romWrite32(addr, input)
    foreign static romReadf32(addr)
    foreign static romWritef32(addr, input)
    foreign static romReadBuffer(addr, length)
    foreign static romWriteBuffer(addr, buf)

    // Impleneted these just for this
    foreign static getMouseX()
    foreign static getMouseY()

    foreign static osdMessage(msg, corner)

    static init() {
        if (FOV > 90) FOV = 90
        if (FOV <= 0) FOV = 0.001
    }

    static onTick(framecount) {
        // Set FPS
        rdramWrite8(0x8013DB1F, FPSMODE)
        rdramWrite8(0x8013D9E7, FPSMODE)
        rdramWritef32(0x8013D8B0, FPSSCALE)

        // Unlocks secrets
        rdramWrite32(0x806CB01A, 0x504F)
        rdramWrite32(0x806CB01C, 0x504F)
        rdramWrite32(0x801659C6, 0xFFFF)
        rdramWrite32(0x801659C4, 0xFFFF)

        // Set player pointer
        PPOINTER = rdramRead32(Turok3Interface.pCPlayerPointer)
        if (PPOINTER != PPOINTERLAST) {
            PPOINTERLAST = PPOINTER
            PLAYER = CPlayer.new(PPOINTER)
        }

        if (framecount > TIMEBEFOREEXECUTE && PPOINTER != 0) {
            var oldp = PITCH
            var oldy = YAW
            PITCH = PITCH - (getMouseY() * M_PITCH * M_MUL)
            YAW = YAW + (getMouseX() * M_YAW * M_MUL)

            PITCH = PITCH > MAXA && MAXA || PITCH < MINA && MINA || PITCH
            YAW = YAW > TAU && YAW - TAU || YAW < -TAU && YAW + TAU || YAW

            DELTAX = PITCH - oldp
            DELTAY = oldy - YAW

            /*
            Fun tests
            var cPos = Vector3.new(
                rdramReadf32(PLAYER.character.m_vPos),
                rdramReadf32(PLAYER.character.m_vPos + 4),
                rdramReadf32(PLAYER.character.m_vPos + 8)
            )
            var fwd = Vector3.new(YAW.sin, 0, YAW.cos)
            cPos = cPos + (fwd * DELTAX * 10)

            rdramWritef32(PLAYER.character.m_vVelocity, fwd.x * 100)
            rdramWritef32(PLAYER.character.m_vVelocity + 4, fwd.y * 100)
            rdramWritef32(PLAYER.character.m_vVelocity + 8, fwd.z * 100)

            rdramWritef32(PLAYER.weapon.m_vPos, cPos.x)
            rdramWritef32(PLAYER.weapon.m_vPos + 4, cPos.y)
            rdramWritef32(PLAYER.weapon.m_vPos2, cPos.x)
            rdramWritef32(PLAYER.weapon.m_vPos2 + 4, cPos.y)*/

            //FOV
            rdramWrite32(0x8008E430, 0)

            rdramWritef32(rdramRead32(PLAYER.m_pCamera) + 0x530, FOV)
            rdramWritef32(rdramRead32(PLAYER.m_pCamera) + 0x534, FOV)

            rdramWritef32(PLAYER.m_vHeadRotOffset, PITCH)
            rdramWritef32(PLAYER.character.m_RotY, YAW)
        }

        if (framecount % 48 == 0) {
            if (framecount < TIMEBEFOREEXECUTE) {
                var delta = TIMEBEFOREEXECUTE - framecount
                System.print("Waiting to execute... %(delta) frames before execution!")
            } else {
                var afov = rdramReadf32(rdramRead32(PLAYER.m_pCamera) + 0x530)
                System.print("Angles: rad; %(PITCH), %(YAW) deg; %(PITCH * RAD2DEG), %(YAW * RAD2DEG)\nFOV: %(FOV), Actual: %(afov)")
            }
        }
    }
}